Stylegeist SDK for Cocoa
========================

Usage
-----

First of all you need to create a client, normally
in the app delegate.

    @interface AppDelegate : UIResponder <UIApplicationDelegate>

    @property (strong, nonatomic) SGClient *stylegeistClient;

    @end

    @implementation AppDelegate

	- (BOOL)application:(UIApplication *)a didFinishLaunchingWithOptions:(NSDictionary *)o
	{
		...
		_stylegeistClient = [[SGClient alloc] init];
	}

    @end

The client must be given credentials in order to
work.  This would normally be done in
a login view controller.

	SGClient *client = [[UIApplication sharedApplication] stylegeistClient];
    client.username = @"johnny";
    client.password = @"12345abc";

You can then create authenticated contexts:

	SGContext *context = [[[UIApplication sharedApplication] stylegeistClient] context];

A Stylegeist entity is created like this:

    SGUser *user = [SGUser insertInContext:context];
    [context save];