#import <Foundation/Foundation.h>


@class SGResource;
@class SGStylesCollection;
@class SGUsersCollection;
@class SGContext;


@interface SGResource : NSObject

@property NSURL *url;
@property NSString *remoteEntityName;
@property BOOL editable;
@property SGResource *original;
@property SGContext *context;

- (BOOL)isUpdated;
- (id)updatedCopy;
- (void)mapFromJSONSerialization:(NSJSONSerialization *)serialization;
- (id)initWithContext:(SGContext *)c remoteEntityName:(NSString *)n;
- (id)initWithContext:(SGContext *)c;
- (SGResource *)next;

@end


@interface SGStylesCollection : SGResource

@property NSMutableArray *styles;
@property NSNumber *total;
@property NSURL *nextURL;

@end


@interface SGCommentsCollection : SGResource

@property NSMutableArray *comments;
@property NSNumber *total;
@property NSURL *nextURL;

@end


@interface SGUsersCollection : SGResource

@property NSMutableArray *users;
@property NSNumber *total;
@property NSURL *nextURL;

@end


@interface SGRating : SGResource

@property NSNumber *average;
@property NSNumber *own;

@end


@interface SGUser : SGResource

@property NSString *tagline;
@property NSString *username;
@property NSString *password;
@property NSString *email;
@property NSData *pictureData;
@property NSURL *pictureURL;
@property NSURL *thumbnailURL;
@property NSURL *editURL;
@property SGStylesCollection *styles;
@property SGUsersCollection *followers;
@property SGUsersCollection *following;

@end


@interface SGComment : SGResource

@property NSString *content;
@property SGUser *user;

@end


@interface SGStyle : SGResource

@property NSURL *thumbnailURL;
@property NSURL *pictureURL;
@property SGCommentsCollection *comments;
@property SGRating *rating;
@property SGUser *user;
@property SGStyle *next;
@property SGStyle *prev;

@end


@interface SGSession : SGResource

@property SGUser *user;
@property NSString *email;
@property NSString *password;

@end