#import <OCMock/OCMock.h>
#import "client_tests.h"
#import "client.h"


@implementation SGClientTests
{
	SGClient *_client;
	NSConditionLock *_lock;
	BOOL _didCallDelegate;
}

- (void)setUp
{
	[super setUp];

	if (!_client) {
		NSString *u = Username;
		NSString *p = Password;
		_client = [[SGClient alloc] initWithUsername:u password:p];
	}
}

- (void)tearDown
{
	[super tearDown];
}

- (void)testInit
{
	STAssertNotNil(_client, @"client shouldn't be nil");
}

- (void)testCredentials
{
	STAssertEquals(_client.username, Username, @"username should match");
	STAssertEquals(_client.password, Password, @"password should match");
}

- (void)connectionDidSucceedForResource:(SGResource *)rsc withHTTPStatusCode:(int)i
{
	_didCallDelegate = YES;
}

- (void)connectionDidFailForResource:(SGResource *)resource withError:(NSError *)error
{
	_didCallDelegate = YES;
}

@end
